# log4cplus::spi Namespace Reference

## Compounds

class | AppenderAttachable
| This Interface is for attaching Appenders to objects. More...
class | AppenderFactory
| This abstract class defines the "Factory" interface to create "Appender" objects. More...
class | BaseFactory
| This is the base class for all factories. More...
class | DenyAllFilter
| This filter drops all logging events. More...
class | FactoryRegistry
| This template class is used as a "Factory Registry". More...
class | Filter
| Users should extend this class to implement customized logging event filtering. More...
class | FilterFactory
| This abstract class defines the "Factory" interface to create "Appender" objects. More...
class | InternalLoggingEvent
| The internal representation of logging events. More...
class | LayoutFactory
| This abstract class defines the "Factory" interface to create "Layout" objects. More...
class | LoggerFactory
| Implement this interface to create new instances of Logger or a sub-class of Logger. More...
class | LoggerImpl
| This is the central class in the log4cplus package. More...
class | LogLevelMatchFilter
| This is a very simple filter based on LogLevel matching. More...
class | LogLevelRangeFilter
| This is a very simple filter based on LogLevel matching, which can be used to reject messages with LogLevels outside a certain range. More...
class | ObjectRegistryBase
| This is the base class used to implement the functionality required by the ObjectRegistry template class. More...
class | RootLogger
| RootLogger sits at the top of the logger hierachy. More...
class | StringMatchFilter
| This is a very simple filter based on string matching. More...

## Typedefs

typedef helpers::SharedObjectPtr< LoggerImpl > | SharedLoggerImplPtr
typedef FactoryRegistry< AppenderFactory > | AppenderFactoryRegistry
typedef FactoryRegistry< LayoutFactory > | LayoutFactoryRegistry
typedef FactoryRegistry< FilterFactory > | FilterFactoryRegistry
typedef helpers::SharedObjectPtr< Filter > | FilterPtr

## Enumerations

enum | FilterResult { DENY, NEUTRAL, ACCEPT }

## Functions

LOG4CPLUS_EXPORT AppenderFactoryRegistry & | getAppenderFactoryRegistry ()
| Returns the "singleton" `AppenderFactoryRegistry`.
LOG4CPLUS_EXPORT LayoutFactoryRegistry & | getLayoutFactoryRegistry ()
| Returns the "singleton" `LayoutFactoryRegistry`.
LOG4CPLUS_EXPORT FilterFactoryRegistry & | getFilterFactoryRegistry ()
| Returns the "singleton" `FilterFactoryRegistry`.
LOG4CPLUS_EXPORT FilterResult | checkFilter (const Filter *filter, const InternalLoggingEvent &event)
| This method is used to filter an InternalLoggingEvent.

## Typedef Documentation

typedef FactoryRegistry<AppenderFactory> log4cplus::spi::AppenderFactoryRegistry

| Definition at line 154 of file factory.h.

typedef FactoryRegistry<FilterFactory> log4cplus::spi::FilterFactoryRegistry

| Definition at line 156 of file factory.h.

typedef helpers::SharedObjectPtr<Filter> log4cplus::spi::FilterPtr

| Definition at line 54 of file filter.h.

typedef FactoryRegistry<LayoutFactory> log4cplus::spi::LayoutFactoryRegistry

| Definition at line 155 of file factory.h.

typedef helpers::SharedObjectPtr<LoggerImpl> log4cplus::spi::SharedLoggerImplPtr

| Definition at line 36 of file logger.h.

## Enumeration Type Documentation

enum log4cplus::spi::FilterResult

Enumeration values:

  DENY | The log event must be dropped immediately without consulting with the remaining filters, if any, in the chain.
  NEUTRAL | This filter is neutral with respect to the log event; the remaining filters, if if any, should be consulted for a final decision.
  ACCEPT | The log event must be logged immediately without consulting with the remaining filters, if any, in the chain.

Definition at line 30 of file filter.h.

## Function Documentation

LOG4CPLUS_EXPORT FilterResult checkFilter | ( | const Filter * | filter,
|  | const InternalLoggingEvent & | event
| ) |

| This method is used to filter an InternalLoggingEvent. Note: `filter` can be NULL.

LOG4CPLUS_EXPORT AppenderFactoryRegistry& getAppenderFactoryRegistry | ( |  | ) |

| Returns the "singleton" `AppenderFactoryRegistry`.

LOG4CPLUS_EXPORT FilterFactoryRegistry& getFilterFactoryRegistry | ( |  | ) |

| Returns the "singleton" `FilterFactoryRegistry`.

LOG4CPLUS_EXPORT LayoutFactoryRegistry& getLayoutFactoryRegistry | ( |  | ) |

| Returns the "singleton" `LayoutFactoryRegistry`.